

#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    public class Zi7CompoundZBvsZN01 : Indicator
    {
        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Blue), PlotStyle.Line, "Spread"));
			CalculateOnBarClose	= true;
            Overlay				= false;
			BarsRequired		= 0;
			
			//--------------------------------------------------------------------
			// El chart principal tiene que ser el ZN (Treasury-bounds a 10 años)
			//--------------------------------------------------------------------
			Add( "ZB 06-10", BarsPeriod.Id, BarsPeriod.Value );	// Instrumento secundario: ZB (T-bonos a 30 años)
        }
		
        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			if ( BarsInProgress == 1 )
				PlotSpread.Set(0, (double)( (decimal)Closes[0][0] - (decimal)Closes[1][0] ) );
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries PlotSpread
        {
            get { return Values[0]; }
        }
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private Zi7CompoundZBvsZN01[] cacheZi7CompoundZBvsZN01 = null;

        private static Zi7CompoundZBvsZN01 checkZi7CompoundZBvsZN01 = new Zi7CompoundZBvsZN01();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Zi7CompoundZBvsZN01 Zi7CompoundZBvsZN01()
        {
            return Zi7CompoundZBvsZN01(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Zi7CompoundZBvsZN01 Zi7CompoundZBvsZN01(Data.IDataSeries input)
        {
            if (cacheZi7CompoundZBvsZN01 != null)
                for (int idx = 0; idx < cacheZi7CompoundZBvsZN01.Length; idx++)
                    if (cacheZi7CompoundZBvsZN01[idx].EqualsInput(input))
                        return cacheZi7CompoundZBvsZN01[idx];

            lock (checkZi7CompoundZBvsZN01)
            {
                if (cacheZi7CompoundZBvsZN01 != null)
                    for (int idx = 0; idx < cacheZi7CompoundZBvsZN01.Length; idx++)
                        if (cacheZi7CompoundZBvsZN01[idx].EqualsInput(input))
                            return cacheZi7CompoundZBvsZN01[idx];

                Zi7CompoundZBvsZN01 indicator = new Zi7CompoundZBvsZN01();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                Indicators.Add(indicator);
                indicator.SetUp();

                Zi7CompoundZBvsZN01[] tmp = new Zi7CompoundZBvsZN01[cacheZi7CompoundZBvsZN01 == null ? 1 : cacheZi7CompoundZBvsZN01.Length + 1];
                if (cacheZi7CompoundZBvsZN01 != null)
                    cacheZi7CompoundZBvsZN01.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheZi7CompoundZBvsZN01 = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.Zi7CompoundZBvsZN01 Zi7CompoundZBvsZN01()
        {
            return _indicator.Zi7CompoundZBvsZN01(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.Zi7CompoundZBvsZN01 Zi7CompoundZBvsZN01(Data.IDataSeries input)
        {
            return _indicator.Zi7CompoundZBvsZN01(input);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.Zi7CompoundZBvsZN01 Zi7CompoundZBvsZN01()
        {
            return _indicator.Zi7CompoundZBvsZN01(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.Zi7CompoundZBvsZN01 Zi7CompoundZBvsZN01(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.Zi7CompoundZBvsZN01(input);
        }
    }
}
#endregion
